/*
 * kctrl.dllgƂp
 */

#ifndef __USE_KCTRL_H__
#define __USE_KCTRL_H__

#include "kctrl.h"

/**
 *
 * @param wcstr ϊ̕BNULL ł OK
 * @param mbstr ϊO̕
 * @param count ϊ镶
 * @return ϊ
 */
size_t _mbstowcs(WCHAR *wcstr, const char *mbstr, size_t count)
{
	/* size_t mbstowcs( wchar_t *wcstr, const char *mbstr, size_t count );
	 *
	 * Parameters
	 *   wcstr		The address of a sequence of wide characters 
	 *   mbstr		The address of a sequence of multibyte characters 
	 *   count		The number of multibyte characters to convert
	 */

#ifdef USE_KCTRL
	return sjis2unicode((LPBYTE)mbstr, (LPTSTR)wcstr, count*2);
#else
	return MultiByteToWideChar( CP_ACP,				/* UINT		CodePage		*/
								MB_PRECOMPOSED,		/* DWORD	dwFlags			*/
								mbstr,				/* LPCSTR	lpMultiByteStr	*/
								-1,					/* int		cbMultiByte		*/
								wcstr,				/* LPWSTR	lpWideCharStr	*/
								count );			/* int		cchWideChar		*/
#endif
}

#define	mbstowcs _mbstowcs

/**
 *
 */
size_t _wcstombs(char *mbstr, const WCHAR *wcstr, size_t count)
{
#ifdef USE_KCTRL
	return unicode2sjis((LPTSTR)wcstr, (LPBYTE)mbstr, count );
#else
	return WideCharToMultiByte( CP_ACP,		/* UINT		CodePage			*/
								0,			/* DWORD	dwFlags				*/
								wcstr,		/* LPCSTR	lpWideCharStr		*/
								-1,			/* int		ccWideChar			*/
								mbstr,		/* LPSTR	lpMultiByteStr		*/
								count,		/* int		cbMultiByte			*/
								NULL,		/* LPCSTR	lpDefaultChar		*/
								NULL );		/* LPBOOL	lpUsedDefaultChar	*/
#endif
}
#define	wcstombs	_wcstombs


#ifdef USE_KCTRL
size_t _MultiByteToWideChar( UINT	CodePage,
							DWORD	dwFlags,
							LPCSTR	lpMultiByteStr,
							int		cbMultiByte,
							LPWSTR	lpWideCharStr,
							int		cchWideChar)
{
	return sjis2unicode((LPBYTE)lpMultiByteStr, (LPTSTR)lpWideCharStr, cchWideChar*2);
}
#define	MultiByteToWideChar	_MultiByteToWideChar

size_t _WideCharToMultiByte(UINT CodePage, DWORD dwFlags, LPCSTR lpWideCharStr, int ccWideChar, LPSTR lpMultiByteStr, int cbMultiByte, LPCSTR lpDefaultChar, LPBOOL lpUsedDefaultChar)
{
	return unicode2sjis((LPTSTR)lpWideCharStr, (LPBYTE)lpMultiByteStr, cbMultiByte);
}
#define	WideCharToMultiBytes	_WideCharToMultiByte
#endif // USE_KCTRL

//-----------------
// Xg{bNXptHg쐬
HFONT CreateMyFont()
{
	LOGFONT         lf ;

	memset( &lf, 0, sizeof lf ) ;
	lf.lfPitchAndFamily = FIXED_PITCH | FF_MODERN ;
//	lf.lfCharSet = SHIFTJIS_CHARSET ; cefontɂchasetݒ肳ĂȂ̂ŎgȂH
	wcscpy(lf.lfFaceName, TEXT("CEFONT"));	// 
	lf.lfHeight = 20;//GetFontH();	//13 ;
	return CreateFontIndirect( &lf ) ;
}


#endif // __USE_KCTRL_H__
